/*
The following code is

© Andreas Amann, 2007-2012
http://andreasamann.com/

You may incorporate this code into your program(s) without restriction.
This code has been provided "AS IS" and the responsibility for its operation is yours.
You are not permitted to redistribute this code under my name after having made changes.
If you're going to redistribute the code, please make it clear that the code was descended
from my code, but that you've made changes.
*/

// main standings class (all sports)
SF_._standings = function(theSport)
{
	this.numPlayoffTeams = function() {return null;}
	this.tableColWidth = null;
	this.footer = "";
	this.standingsLinkList = new Array();
	this.clear();
	this.initialize(theSport);
}

SF_._standings.prototype.clear = function()
{
	this.teams = null;
	this.theIndex = null;
	this.xmlRequest = null;
	this.reloadTimer = null;
	this.popupTimer = null;
	this.header1 = null;
	this.header2 = null;
	this.showFooter = false;
}

SF_._standings.prototype.getPolls = function()
{
	this.standingsLinkList = [];
}

SF_._standings.prototype.draw = function()
{
	this.showFooter = false;
	var standingsHeader = "<table><tr>";
	standingsHeader += "<th width='" + (this.tableColWidth[0] + this.tableColWidth[1]) + "%'>" + WC_.sanitizeString(this.header2[0].replace(/-/g,"&#8209;").replace(/ +/g," ")) + "</th>";
	for (var i = 2, len = this.tableColWidth.length; i < len; i++)
		standingsHeader += "<th width='" + this.tableColWidth[i] + "%' class='stNum'>" + WC_.sanitizeString(this.header2[i-1].replace(/-/g,"&#8209;").replace(/ +/g," ")) + "</th>";
	$("standingsHeader").innerHTML = standingsHeader + "</tr></table>";
	var standingsTable = "<table>";
	for (var iTeam in this.teams)
	{
		this.showFooter = this.showFooter || this.teams[iTeam].clinchDetails != "";
		standingsTable += "<tr class='" + (iTeam % 2 == 0 ? "odd " : "") + (SF_.prefs.favoriteTeam != -1 && SF_.prefs.favoriteTeam == this.teams[iTeam].teamIndex ? "st_fav " : "") + (this.teams[iTeam].isEliminated ? "elim " : "") + (this.numPlayoffTeams() && this.numPlayoffTeams() == iTeam ? "playoffLimit " : "") + "team_" + iTeam + "' onmouseup=SF_.showTeamPage('" + this.teams[iTeam].teamIndex + "');" + (this.teams[iTeam].details.length + 2 <= this.tableColWidth.length ? "" : " onmouseover=SF_.theStandings.showTeamDetails(" + iTeam + ");") + ">";
		standingsTable += "<td width='" + this.tableColWidth[0] + "%'>" + (this.teams[iTeam].rank ? this.teams[iTeam].rank + " - " : "") + WC_.sanitizeString(this.teams[iTeam].teamName.replace(/-/g,"&#8209;").replace(/ +/g," ")) + "</td><td class='stClinch' width='" + this.tableColWidth[1] + "%'>" + WC_.sanitizeString(this.teams[iTeam].clinchDetails.replace(/-/g,"&#8209;").replace(/ +/g," ")) + "</td>";
		for (var iCell = 0, cellLen = this.tableColWidth.length - 2; iCell < cellLen; iCell++)
			standingsTable += "<td width='" + this.tableColWidth[iCell+2] + "%' class='stNum'>" + WC_.sanitizeString(this.teams[iTeam].details[iCell].replace(/-/g,"&#8209;").replace(/ +/g," ")) + "</td>";
		standingsTable += "</tr>";
	}
	$s("mainContent").top = $s("ContentScrollbar").top = ($("standingsHeader").offsetHeight/parseInt(document.defaultView.getComputedStyle($("standingsHeader")).getPropertyValue("font-size"),10) + 1.5) + "em";
	$("mainContent").innerHTML = standingsTable + "</table>";
	$s("mainContent").bottom = this.showFooter ? "1.9em" : ".4em";
	$("standingsFooter").innerHTML = this.footer;
	$s("standingsFooter").visibility = this.showFooter ? "visible" : "";
	$s("ContentScrollbar").bottom = this.showFooter ? "2.8em" : "1.5em";
	var showScrollbar = (this.teams.length > (this.maxTeams - (this.showFooter ? 1 : 0)));
	$s("ContentScrollbar").visibility = showScrollbar ? "visible" : "";
	SF_.closePopup();
	SF_.sizeWidget();
	WC_.stopSpinner("ReloadSpinner");
	this.reloadTimer = setTimeout(function(){SF_.theStandings.load();},1800000);
	SF_.ignoreMouseUp = false;
}

SF_._standings.prototype.load = function()
{
	SF_.ignoreMouseUp = true;
	var temp = SF_.abortOngoingRequests();
	SF_.theScoreBoard.clear();
	$("titleMenu").innerHTML = "";
	$("sbMenu").innerHTML = "Scoreboard";
	$("stMenu").innerHTML = "<span class='activeMenu'>Standings</span>";
	WC_.animateSpinner("ReloadSpinner");
	if ($("mainContent").innerText == "Data Unavailable" )
		$("mainContent").innerHTML = "";
	this.theIndex = $("stPopup").selectedIndex;
	SF_.prefs.currentDisplay = this.theIndex;
	WC_.setInstancePref("currentDisplay", this.theIndex);
	var _self = this;
	this.xmlRequest = new XMLHttpRequest();
	this.xmlRequest.onload = function() {_self.parse();}
	this.xmlRequest.open("GET",this.standingsLink());
	this.xmlRequest.setRequestHeader("Cache-Control", "no-cache");
	this.xmlRequest.setRequestHeader("Cookie", "");
	this.xmlRequest.send(null);
}

SF_._standings.prototype.showTeamDetails = function(iTeam)
{
	if ($s("ReloadSpinner").visibility == "visible") return;
	if (this.popupTimer != null)
		clearTimeout(this.popupTimer);
	if (!this.header2 || !this.teams) return;
	$("mainContent").innerHTML = $("mainContent").innerHTML.replace(/ selected/g,"").replace(new RegExp("(team_" + iTeam + ")","g"),"$1 selected");
	var teamDetails = "<table><tr>" + (this.header1 || "");
	var colWidth = 100 / (Math.min(this.header2.length,this.teams[iTeam].details.length + 1) - this.tableColWidth.length + 1);
	for (var i = this.tableColWidth.length - 1, len = Math.min(this.header2.length,this.teams[iTeam].details.length + 1); i < len; i++)
		teamDetails += "<th class='stDetails' width='" + colWidth + "%'>" + WC_.sanitizeString(this.header2[i].replace(/-/g,"&#8209;").replace(/ +/g," ")) + "</th>";
	teamDetails += "</tr><tr>";
	for (var i = this.tableColWidth.length - 2, len = Math.min(this.header2.length - 1,this.teams[iTeam].details.length); i < len; i++)
		teamDetails += "<td class='stDetails' width='" + colWidth + "%'>" + WC_.sanitizeString(this.teams[iTeam].details[i].replace(/-/g,"&#8209;").replace(/ +/g," ")) + "</td>";
	$("scoreDetails").innerHTML = teamDetails + "</tr></table>";
	$s("scoreDetails").width = $("frontContent").offsetWidth + "px";
	$s("gameDetails").left = "1em";
	$s("gameDetails").height = this.header1 ? "4em" : "2.9em";
	$s("gameDetails").width = ($("scoreDetails").offsetWidth + 4) + "px";
	$s("gameDetails").visibility = "visible";
	WC_.refreshView();
	var _self = this;
	setTimeout("$('gameDetails').onmouseover = function() { SF_.closePopup();}",1000);
	this.popupTimer = setTimeout(function(){SF_.closePopup(_self);},10000);
}

// custom class setup and functions (individual sports)
SF_._standings.prototype.initialize = function(theType)
{
	switch (theType)
	{
		case "MLB":
			this.tableColWidth = [50,0,11,11,14,14];
			this.standingsLink = function(){
                var theDate = new Date();
				if (SF_.prefs.currentLeague == "MLB")
					return "http://mlb.mlb.com/lookup/json/named.standings_schedule_date.bam?season=" + theDate.getFullYear() + "&schedule_game_date.game_date='" + theDate.getFullYear() + "/" + WC_.twoDigNum(theDate.getMonth() + 1) + "/" + WC_.twoDigNum(theDate.getDate()) + "'&sit_code='h0'&league_id=103&league_id=104&all_star_sw='N'&version=2";
				else
					return "http://www.milb.com/lookup/json/named.standings_display_flip.bam?sit_code=%27h0%27&org_id=112&season=" + theDate.getFullYear() + "&league_id=" + this.standingsLinkList[this.theIndex].split("|")[0];
			}
			this.maxTeams = 6;
			this.parse = this.parse_MLB;
			break;
		case "NBA":
			this.footer = "<table><tr><td width='50%' style='text-align:center;'>x-clinched playoff berth</td><td width='50%' style='text-align:center;'>y-clinched division title</td></tr></table>";
			this.standingsLink = function(){
				if (SF_.prefs.currentLeague == "NBA")
					return "http://www.espn.com/nba/standings" + (this.theIndex == 3 || this.theIndex == 7 ? "" : "/_/group/division");
				else if (SF_.prefs.currentLeague == "WNBA")
					return "http://www.wnba.com/standings/team_record_comparison/conferenceNew_Std_Cnf.html";
				else
					return "http://www.cbssports.com/collegebasketball/" + this.standingsLinkList[this.theIndex].split("|")[0];
			}
			this.maxTeams = 7;
			this.numPlayoffTeams = function()
			{
				if (SF_.prefs.currentLeague == "NBA")
					return 8;
				else if (SF_.prefs.currentLeague == "WNBA")
					return 4;
				else
					return null;
			}
			this.parse = this.parse_NBA;
			this.getPolls = this.getPolls_NBA;
			break;
		case "NFL":
			this.footer = "<table><tr><td>x-clinched playoff berth<br />y-clinched division title</td><td>z-clinched first-round bye<br />*-clinched homefield advantage</td></tr></table>";
			this.standingsLink = function(){
				if (SF_.prefs.currentLeague == "NFL")
					return "http://www.cbssports.com/nfl/standings/";
				else
					return "http://www.cbssports.com/collegefootball/" + this.standingsLinkList[this.theIndex].split("|")[0];
			}
			this.maxTeams = 8;
			this.parse = this.parse_NFL;
			this.getPolls = this.getPolls_NFL;
			break;
		case "NHL":
			this.footer = "<table><tr><td>x-clinched playoff berth<br />y-clinched division title</td><td>z-clinched conference<br /> </td></tr></table>";
			this.standingsLink = function(){return "http://www.cbssports.com/nhl/standings/regular/" + (this.theIndex == 2 || this.theIndex == 5 ? "conference" : "division");}
			this.maxTeams = 6;
			this.numPlayoffTeams = function(){return 8;}
			this.parse = this.parse_NHL;
			break;
	}
}

SF_._standings.prototype.parse_NHL = function()
{
	if (!this.xmlRequest) return;
	this.teams = new Array();
	var xmlResponse = this.xmlRequest.responseText;
	this.xmlRequest = null;
	if (!xmlResponse)
	{
		SF_.theScoreBoard.customText("Data Unavailable");
		return;
	}
	var isConference = this.theIndex == 2 || this.theIndex == 5;
	this.tableColWidth = [45,7,12,12,12,12];
	var isPreseason = false;
	xmlResponse = xmlResponse.replace(/[\n\r]/g,"");
	xmlResponse = xmlResponse.match(new RegExp("> *" + ["Atlantic","Metropolitan","Eastern","Central","Pacific","Western"][this.theIndex] + ".*?(?:headGroupTr|<\/table>)" + (isConference ? ".*?<\/table>" : ""),"g"))[0];
	xmlResponse = "<tr><td><" + xmlResponse;
	if (isConference)
		xmlResponse = xmlResponse.replace(/<\/table>.*?<tr.*?<\/tr>/,"");
	xmlResponse = xmlResponse.match(/<tr.*?<\/tr>/g);
	this.header1 = null;
	this.header2 = [isConference ? (this.theIndex == 2 ? "Eastern" : "Western") : xmlResponse[0].replace(/.*?td.*?>([^<]*)\s*<\/.*/,"$1")];
	for (var iCell = isConference ? 1 : 0, cellLen = xmlResponse[isConference ? 1 : 0].match(/<th.*?<\/th>/g).length, headerArray = xmlResponse[isConference ? 1 : 0].match(/<th.*?<\/th>/g).join('|').replace(/<.*?>/g,"").split('|'); iCell < Math.min(12, cellLen); iCell++)
		this.header2.push(headerArray[iCell].replace(/ *([^ ]*).*/,"$1"));
	for (var iTeam = (isConference ? 2 : 1), teamLen = xmlResponse.length; iTeam < teamLen; iTeam++)
	{
		if (xmlResponse[iTeam].match(/<td.*?<\/td>/g).length > 1)
		{
			var theArray = xmlResponse[iTeam].match(/<td.*?<\/td>/g).join('|').replace(/<td.*?>(?:<nobr>[0-9 ]*)?(.*?)-?<a.*?\/(?:page|teams)\/([^/]*).*?>(.*?)<\/a>/i,"$2|$3|$1").replace(/<.*?>/g,"").replace(/\|[0-9]+\.\s*/,"|").split('|');
			this.teams.push({
				teamIndex: SF_.getTeamIndex("shortName", theArray[0]),
				isEliminated: false,
				clinchDetails: theArray[1],
				teamName: theArray[2],
				details: theArray
			});
			this.teams[this.teams.length-1].details.splice(0,3);
		}
	}
	this.draw();
}

SF_._standings.prototype.getPolls_NBA = function()
{
	if (SF_.prefs.currentLeague.match(/NBA/))
		this.standingsLinkList = [];
	else
		this.standingsLinkList = [
			{name:"AP Top 25", link:"rankings/ap|-1|0"},
			{name:"Coaches Poll", link:"rankings/coaches|-1|0"}
		];
}

SF_._standings.prototype.parse_NBA = function()
{
	if (!this.xmlRequest) return;
	this.teams = new Array();
	var xmlResponse = this.xmlRequest.responseText;
	this.xmlRequest = null;
	if (!xmlResponse)
	{
		SF_.theScoreBoard.customText("Data Unavailable");
		return;
	}
	xmlResponse = xmlResponse.replace(/[\n\r]/g,"");
	this.header1 = null;
	var teamIndexes = [0,0];
	if (SF_.prefs.currentLeague.match(/NBA/))
	{
		var isConference = this.theIndex == 3 || this.theIndex == 7;
		this.tableColWidth = [53,5,8,8,14,12];
		if (SF_.prefs.currentLeague == "NBA")
		{
			this.header2 = ["Atlantic","Central","Southeast","Eastern","Northwest","Pacific","Southwest","Western"][this.theIndex];
            xmlResponse = xmlResponse.match(new RegExp(["Eastern", "Western"][this.theIndex <= 3 ? 0 : 1] + " Conference.*?Table2__sub-header.*?</section>", "ig"))[0];
            xmlResponse = xmlResponse.match(/Table2__sub-header.*?<\/(?:table|section)>/ig);
            xmlResponse = xmlResponse[0] + xmlResponse[1];
            xmlResponse = xmlResponse.match(/..*?(?:Table2__sub-header|<\/table>)/ig);
            xmlResponse = "<tr>" + xmlResponse[isConference ? 0 : (this.theIndex - (this.theIndex < 3 ? 0 : 4))] + "<tr>" + xmlResponse[isConference ? 1 : (3 + this.theIndex - (this.theIndex < 3 ? 0 : 4))];
            this.header2 = [this.header2 + (isConference ?  " Conference" : " Division")];
        }
		else
		{
			this.header2 = [["East Conference","West Conference"][this.theIndex]];
			xmlResponse = xmlResponse.match(new RegExp("<div[^>]*>" + this.header2 + ".*?(?:class=\"confTitle\"|<\/table>)", "gi"))[0];
		}
		xmlResponse = xmlResponse.match(/<(?:thead|tr).*?<\/(?:thead|tr)>/ig);
        var splicedArray = [];
        for (var i = 0; i < xmlResponse.length / 2; i++)
        {
            splicedArray.push((xmlResponse[i]+xmlResponse[i+xmlResponse.length/2]).replace(/<\/tr><tr/, ""));
        }
        xmlResponse = splicedArray;
	}
	else
	{
		teamIndexes = [parseInt(this.standingsLinkList[this.theIndex].split("|")[1],10), parseInt(this.standingsLinkList[this.theIndex].split("|")[2],10)];
		this.tableColWidth = teamIndexes[0] < 0 ? [61,0,13,13,13] : [61,0,12,12,15];
		var updateString = xmlResponse.match(/>Rankings updated.*?\(.*?\)/);
		updateString = updateString ? updateString[0].replace(/.*(\(.*)/," $1") : "";
		xmlResponse = xmlResponse.match(/<table class="?data.*?<\/table>/ig)[0]; //"
		xmlResponse = xmlResponse.replace(/<tr[^>]*id=special.*?<\/tr>/ig,"");
		xmlResponse = xmlResponse.match(/<tr.*?<\/tr>/ig);
		this.header2 = [xmlResponse[0].replace(/.*?td.*?>([^<]*)\s*<\/td.*/i,"$1 ") + (teamIndexes[0] < 0 || $("stPopup").value.match(/Conference/) ? "" : " " + $("stPopup").value) + updateString];
		xmlResponse.splice(0, 2 + (teamIndexes[0] > 0 ? 2 + teamIndexes[0] : (teamIndexes[0] < 0 ? 1 : 0)));
		if (teamIndexes[0] < 0)
		{
			xmlResponse.splice(0,0,"<td></td><td>Record</td><td>Points</td><td>Prev</td>");
			if (xmlResponse.length > 26)
				xmlResponse.splice(26,xmlResponse.length - 26);
		}
		if (teamIndexes[1])
			xmlResponse.splice(teamIndexes[1] + 2,xmlResponse.length);
		this.header1 = "<th colspan='3'>Conference</th><th></th><th colspan='2'>Home</th><th colspan='2'>Away</th></tr>";
	}
	for (var i = 1, len = xmlResponse[0].match(/<t(?:h|d).*?(?:<\/t(?:h|d)|\/)>/ig).length; i < len; i++)
		this.header2.push(xmlResponse[0].match(/<t(?:h|d).*?(?:<\/t(?:h|d)|\/)>/ig)[i].replace(/<.*?>/g,""));
	for (var iTeam = 1, teamLen = xmlResponse.length; iTeam < teamLen; iTeam++)
	{
		var theArray = xmlResponse[iTeam].match(/<td.*?<\/td>/ig);
		theArray.splice(1,0,theArray[0].match(/.*?(<sup.*sup>).*/i) ? theArray[0].replace(/.*?(<sup.*sup>).*/i,"$1") : "");
		theArray[0] = theArray[0].replace(/<sup.*sup>/i,"");
		var teamIndex = SF_.prefs.currentLeague.match(/NBA/) ? SF_.getTeamIndex("standingsName",theArray[0].replace(/.*?<abbr.*?>(.*?)<.*/,"$1")) : SF_.getTeamIndex("shortName", theArray[teamIndexes[0] < 0 ? 2 : 0].replace(/.*?page\/([^>\"\/]*).*/,"$1")); //"
		if (teamIndexes[0] < 0)
			theArray[3] = theArray[2].replace(/.*?Overall: +(.*?)<.*/,"$1");
		theArray = theArray.join('|').replace(/[\t  ]*<.*?>[\t  ]*/g,"").replace(/ +/," ").split('|');
		var rank = null;
		var isEliminated = false;
		if (SF_.prefs.currentLeague == "NCAAB")
		{
			// re-order to show overall stats before conference stats
			theArray = theArray.join('|').replace(/(.*?\|.*?)(\|.*?\|.*?\|.*?)(\|.*?\|.*?\|.*?)(\|.*?)/,"$1$3$2$4").split('|');
			if (teamIndexes[0] < 0)
			{
				rank = parseInt(theArray[0],10);
				theArray.splice(0,2);
				theArray.splice(1,0,"");
			}
		}
		else
		{
			isEliminated = theArray[1].match(/o$/) != null;
			theArray[1] = theArray[1].replace(/^[0-9]+[\t  ]*/,"").replace(/^o$/,"").replace(/^(s?e|(s|n)?w|a|c|p)$/,"y");
		}
		var teamName = SF_.prefs.currentLeague.match(/NBA/) || teamIndexes[0] < 0 ? SF_.teams[SF_.prefs.currentLeague][teamIndex].fullName : theArray[0];
		if (teamName.length > 24)
			teamName = teamName.substring(0,24) + "…";
		this.teams.push({
			teamIndex: teamIndex,
			isEliminated: isEliminated,
			rank: rank,
			clinchDetails: theArray[1],
			teamName: teamName,
			details: theArray
		});
		this.teams[this.teams.length-1].details.splice(0,2);
	}
	this.draw();
}

SF_._standings.prototype.getPolls_NFL = function()
{
	if (SF_.prefs.currentLeague == "NFL")
		this.standingsLinkList = [];
	else
		this.standingsLinkList = [
			{name:"AP Top 25", link:"rankings/ap|-1|0"},
			{name:"Coaches Poll", link:"rankings/coaches|-1|0"},
			{name:"BCS Standings", link:"rankings/bcs|-2|0"}
		];
}

SF_._standings.prototype.parse_NFL = function()
{
	if (!this.xmlRequest) return;
	this.teams = new Array();
	var xmlResponse = this.xmlRequest.responseText;
	this.xmlRequest = null;
	if (!xmlResponse)
	{
		SF_.theScoreBoard.customText("Data Unavailable");
		return;
	}
	xmlResponse = xmlResponse.replace(/[\n\r]/g,"");
	this.header1 = null;
	var teamIndexes = [0,0];
	if (SF_.prefs.currentLeague == "NFL")
	{
		var isPreseason = false;
		this.tableColWidth = [48,7,10,10,10,15];
		if (xmlResponse.match(/class="?PageTabsNav-item is-selected.*?><a[^>]*\/standings/i))	//"
		{
			if (xmlResponse.match(/class="?PageTabsNav-item is-selected.*?><a[^>]*\/standings\/preseason/i))	//"
			{
				isPreseason = true;
				this.tableColWidth = [56,0,8,8,8,10,10];
			}
		}
		xmlResponse = xmlResponse.match(new RegExp("<span class=\"?TeamLogoNameLockup-name.*?" + (this.theIndex < 4 ? "A" : "N") + "FC.*?" + ["East","North","South","West"][this.theIndex % 4]+ ".*?(?:TableBase-headGroupTr|<\/table>)"))[0].replace(/>.*([AN]FC).*(East|North|South|West).*?</i,"<tr><th>$1 $2<");
		xmlResponse = xmlResponse.match(/<tr.*?<\/tr>/ig);
		this.header2 = [xmlResponse[0].replace(/.*?th.*?>([^<]*)\s*<\/th.*/i,"$1 ")];
	}
	else
	{
		teamIndexes = [parseInt(this.standingsLinkList[this.theIndex].split("|")[1],10), parseInt(this.standingsLinkList[this.theIndex].split("|")[2],10)];
		switch (teamIndexes[0])
		{
			case -2:
				this.tableColWidth = [65,0,35];
				break;
			case -1:
				this.tableColWidth = [61,0,13,13,13];
				break;
			default:
				this.tableColWidth = [53,7,10,10,10,10];
				break;
		}
		var updateString = "";
		if (teamIndexes[0] == -1)
			xmlResponse = xmlResponse.match(/<table id="mainContentTable".*?othervotes/ig)[0];
		else if (teamIndexes[0] == -2)
		{
			updateString = xmlResponse.match(/>Rankings updated.*?\(.*?\)/);
			updateString = updateString ? updateString[0].replace(/.*(\(.*)/i," $1") : "";
		}
		if (teamIndexes[0] != -1)
        {
            xmlResponse = xmlResponse.match(/<table class="data".*?<\/div>/ig)[0];
            xmlResponse = xmlResponse.replace(/<tr[^>]*id=special.*?<\/tr>/ig,"");
        }
		xmlResponse = xmlResponse.match(/<tr.*?<\/tr>/ig);
		this.header2 = [xmlResponse[0].replace(/.*?td.*?>([^<]*)\s*<\/td.*/i,"$1 ") + (teamIndexes[0] < 0 || $("stPopup").value.match(/Conference/) ? "" : " " + $("stPopup").value) + updateString];
		xmlResponse.splice(0, 2 + (teamIndexes[0] > 0 ? 2 + teamIndexes[0] : (teamIndexes[0] == -1 ? 1 : 0)));
		if (teamIndexes[0] == -2)
			xmlResponse.splice(0,0,"<td></td><td>BCS Average</td>");
		else if (teamIndexes[0] == -1)
			xmlResponse.splice(0,0,"<td></td><td>Record</td><td>Pts</td><td>Chg</td>");
		if (teamIndexes[1])
			xmlResponse.splice(teamIndexes[1] + 2,xmlResponse.length);
		this.header1 = teamIndexes[0] == -1 ? "" : "<th colspan='4'>Overall</th><th></th><th colspan='2'>Home</th><th colspan='2'>Away</th></tr>";
	}
	for (var i = 1, len = xmlResponse[0].match(/<t[dh].*?<\/t[dh]>/ig).length; i < len; i++)
		this.header2.push(xmlResponse[0].match(/<t[dh].*?<\/t[dh]>/ig)[i].replace(/<.*?>([^<]*).*/,"$1"));
	for (var iTeam = 1, teamLen = xmlResponse.length; iTeam < teamLen; iTeam++)
	{
		var theArray = xmlResponse[iTeam].replace(/<t[dh][^<]*grouped.*/,"").match(/<td.*?<\/td>/ig);
		theArray.splice(1,0,theArray[0].match(/<td.*?>(?:<nobr>[0-9 ]*)?(.*?)-?<a/i) ? theArray[0].replace(/<td.*?>(?:<nobr>[0-9 ]*)?(.*?)-?<a.*/i,"$1") : "");
		theArray[0] = theArray[0].replace(/.*?<a/i,"<a");
		if (teamIndexes[0] >= 0 
			|| theArray[0].match(/<td.*?>(<font.*>)?[0-9]+(<\/font>)?<\/td>/)
			|| theArray[0].match(/<td.*?>.*?rankTableCol.*?<\/td>/))
		{
			var teamIndexCol = 0;
			if (teamIndexes[0] == -1)
				teamIndexCol = 7;
			else if (teamIndexes[0] == -2)
				teamIndexCol = 2;
			var teamIndex = SF_.getTeamIndex("shortName", theArray[teamIndexCol].replace(/.*?(?:page|teams)\/([^>\"\/]*).*/,"$1")); //"
			if (teamIndexes[0] == -1)
			{
				theArray[3] = theArray[7].replace(/.*?Overall:.*?\((.*?)\).*/,"$1");
				theArray[4] = theArray[9];
				theArray[7] = "";
				theArray.splice(6,4);
			}
			theArray = theArray.join('|').replace(/<.*?>/g,"").split('|');
            if (theArray[0].match(/ - /)) {
                var theParts = theArray[0].split(" - ");
                if (theParts.length == 2) {
                    theArray[0] = theParts[0].trim();
                    theArray[1] = theParts[1].trim();
                }
            }
			var rank = null;
			if (SF_.prefs.currentLeague != "NFL")
			{
				if (teamIndexes[0] < 0)
				{
					rank = parseInt(theArray[0],10);
					theArray.splice(0,2);
					theArray.splice(1,0,"");
					if (teamIndexes[0] == -1)
						theArray[0] = SF_.teams[SF_.prefs.currentLeague][teamIndex].fullName;
					if (teamIndexes[0] == -2)
						theArray.splice(3,theArray.length);
					if (theArray[0].length > 20) theArray[0] = theArray[0].substring(0,20) + "…";
				}
			}
			this.teams.push({
				teamIndex: teamIndex,
				isEliminated: false,
				rank: rank,
				clinchDetails: theArray[1].trim(),
				teamName: theArray[0],
				details: theArray
			});
			this.teams[this.teams.length-1].details.splice(0,2);
		}
	}
	theArray = null;
	xmlResponse = null;
	this.draw();
}

SF_._standings.prototype.parse_MLB = function()
{
	if (!this.xmlRequest) return;
	this.teams = new Array();
	var xmlResponse = this.xmlRequest.responseText;
	this.xmlRequest = null;
	if (!xmlResponse)
	{
		SF_.theScoreBoard.customText("Data Unavailable");
		return;
	}
	var leagueLabel = "";
	this.header1 = null;
    var json = JSON.parse(xmlResponse);
    var divisionNum = SF_.prefs.currentLeague == "MLB" ? [201,202,200,103,204,205,203,104][this.theIndex] : this.standingsLinkList[this.theIndex].split("|")[1];
    var allTeams = [];
    if (SF_.prefs.currentLeague == "MLB")
    {
        leagueLabel = ["AL East","AL Central","AL West","AL Wildcard","NL East","NL Central","NL West","NL Wildcard"][this.theIndex];
        if (divisionNum >= 200)
            allTeams = json.standings_schedule_date.standings_all_date_rptr.standings_all_date[this.theIndex > 3 ? 0 : 1].queryResults.row;
        else
            allTeams = json.standings_schedule_date.standings_wild_card_date_rptr.standings_wild_card_date[this.theIndex > 3 ? 0 : 1].queryResults.row;
    }
    else
    {
        allTeams = json.standings_display_flip.standings_all.queryResults.row;
    }
    for (var i in  allTeams)
    {
        if ((SF_.prefs.currentLeague == "MLB" && divisionNum < 200) || parseInt(allTeams[i].division_id,10) == divisionNum)
        {
            var thisTeam = allTeams[i];
            if (leagueLabel == "")
                leagueLabel = thisTeam.division.replace(/ League/,"");
            this.teams.push({
                teamIndex: SF_.getTeamIndex("shortName", thisTeam.file_code),
                isEliminated: thisTeam.elim == "E",
                clinchDetails: "",
                teamName: thisTeam.team_short,
                details: [
                    thisTeam.w,
                    thisTeam.l,
                    thisTeam.pct,
                    thisTeam.gb,
                    thisTeam.elim,
                    thisTeam.last_ten,
                    thisTeam.streak,
                    thisTeam.home,
                    thisTeam.away,
                    thisTeam.runs,
                    thisTeam.opp_runs
                ]
            });
        }
    }
    this.header2 = [leagueLabel,"W","L","PCT",SF_.prefs.currentLeague == "MLB" && divisionNum < 200 ? "WCGB" : "GB",SF_.prefs.currentLeague == "MLB" && divisionNum < 200 ? "WCE#" : "E#","L10","Strk","Home","Road","RS","RA"];
	this.draw();
}

//
